namespace PkmnLib.Plugin.Gen7.Scripts.Abilities;

/// <summary>
/// Full Metal Body is an ability that prevents the Pokémon's stats from being lowered by other Pokémon's moves or abilities.
/// This ability is exclusive to Solgaleo.
///
/// <see href="https://bulbapedia.bulbagarden.net/wiki/Full_Metal_Body_(Ability)">Bulbapedia - Full Metal Body</see>
/// </summary>
[Script(ScriptCategory.Ability, "full_metal_body")]
public class FullMetalBody : Script, IScriptPreventStatBoostChange
{
    /// <inheritdoc />
    public void PreventStatBoostChange(IPokemon target, Statistic stat, sbyte amount, bool selfInflicted,
        ref bool prevent)
    {
        if (selfInflicted)
            return;

        prevent = true;
    }
}